/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.liferay.docs.insult.model;

import com.liferay.portal.kernel.bean.AutoEscape;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.model.BaseModel;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.StagedGroupedModel;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;

import java.io.Serializable;

import java.util.Date;

/**
 * The base model interface for the Insult service. Represents a row in the
 * &quot;Insult_Insult&quot; database table, with each column mapped to a
 * property of this class.
 *
 * <p>
 * This interface and its corresponding implementation
 * {@link com.liferay.docs.insult.model.impl.InsultModelImpl} exist only as a
 * container for the default property accessors generated by ServiceBuilder.
 * Helper methods and all application logic should be put in
 * {@link com.liferay.docs.insult.model.impl.InsultImpl}.
 * </p>
 *
 * @author joebloggs
 * @see Insult
 * @see com.liferay.docs.insult.model.impl.InsultImpl
 * @see com.liferay.docs.insult.model.impl.InsultModelImpl
 * @generated
 */
public interface InsultModel extends BaseModel<Insult>, StagedGroupedModel {
	/*
	 * NOTE FOR DEVELOPERS:
	 * 
	 * Never modify or reference this interface directly. All methods that
	 * expect a insult model instance should use the {@link Insult} interface
	 * instead.
	 */
	
	/**
	 * Returns the primary key of this insult.
	 *
	 * @return the primary key of this insult
	 */
	public long getPrimaryKey();
	
	/**
	 * Sets the primary key of this insult.
	 *
	 * @param primaryKey
	 *            the primary key of this insult
	 */
	public void setPrimaryKey(long primaryKey);
	
	/**
	 * Returns the uuid of this insult.
	 *
	 * @return the uuid of this insult
	 */
	@AutoEscape
	@Override
	public String getUuid();
	
	/**
	 * Sets the uuid of this insult.
	 *
	 * @param uuid
	 *            the uuid of this insult
	 */
	@Override
	public void setUuid(String uuid);
	
	/**
	 * Returns the insult ID of this insult.
	 *
	 * @return the insult ID of this insult
	 */
	public long getInsultId();
	
	/**
	 * Sets the insult ID of this insult.
	 *
	 * @param insultId
	 *            the insult ID of this insult
	 */
	public void setInsultId(long insultId);
	
	/**
	 * Returns the insult string of this insult.
	 *
	 * @return the insult string of this insult
	 */
	@AutoEscape
	public String getInsultString();
	
	/**
	 * Sets the insult string of this insult.
	 *
	 * @param insultString
	 *            the insult string of this insult
	 */
	public void setInsultString(String insultString);
	
	/**
	 * Returns the user ID of this insult.
	 *
	 * @return the user ID of this insult
	 */
	@Override
	public long getUserId();
	
	/**
	 * Sets the user ID of this insult.
	 *
	 * @param userId
	 *            the user ID of this insult
	 */
	@Override
	public void setUserId(long userId);
	
	/**
	 * Returns the user uuid of this insult.
	 *
	 * @return the user uuid of this insult
	 * @throws SystemException
	 *             if a system exception occurred
	 */
	@Override
	public String getUserUuid() throws SystemException;
	
	/**
	 * Sets the user uuid of this insult.
	 *
	 * @param userUuid
	 *            the user uuid of this insult
	 */
	@Override
	public void setUserUuid(String userUuid);
	
	/**
	 * Returns the group ID of this insult.
	 *
	 * @return the group ID of this insult
	 */
	@Override
	public long getGroupId();
	
	/**
	 * Sets the group ID of this insult.
	 *
	 * @param groupId
	 *            the group ID of this insult
	 */
	@Override
	public void setGroupId(long groupId);
	
	/**
	 * Returns the company ID of this insult.
	 *
	 * @return the company ID of this insult
	 */
	@Override
	public long getCompanyId();
	
	/**
	 * Sets the company ID of this insult.
	 *
	 * @param companyId
	 *            the company ID of this insult
	 */
	@Override
	public void setCompanyId(long companyId);
	
	/**
	 * Returns the user name of this insult.
	 *
	 * @return the user name of this insult
	 */
	@AutoEscape
	@Override
	public String getUserName();
	
	/**
	 * Sets the user name of this insult.
	 *
	 * @param userName
	 *            the user name of this insult
	 */
	@Override
	public void setUserName(String userName);
	
	/**
	 * Returns the create date of this insult.
	 *
	 * @return the create date of this insult
	 */
	@Override
	public Date getCreateDate();
	
	/**
	 * Sets the create date of this insult.
	 *
	 * @param createDate
	 *            the create date of this insult
	 */
	@Override
	public void setCreateDate(Date createDate);
	
	/**
	 * Returns the modified date of this insult.
	 *
	 * @return the modified date of this insult
	 */
	@Override
	public Date getModifiedDate();
	
	/**
	 * Sets the modified date of this insult.
	 *
	 * @param modifiedDate
	 *            the modified date of this insult
	 */
	@Override
	public void setModifiedDate(Date modifiedDate);
	
	@Override
	public boolean isNew();
	
	@Override
	public void setNew(boolean n);
	
	@Override
	public boolean isCachedModel();
	
	@Override
	public void setCachedModel(boolean cachedModel);
	
	@Override
	public boolean isEscapedModel();
	
	@Override
	public Serializable getPrimaryKeyObj();
	
	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj);
	
	@Override
	public ExpandoBridge getExpandoBridge();
	
	@Override
	public void setExpandoBridgeAttributes(BaseModel<?> baseModel);
	
	@Override
	public void setExpandoBridgeAttributes(ExpandoBridge expandoBridge);
	
	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext);
	
	@Override
	public Object clone();
	
	@Override
	public int compareTo(Insult insult);
	
	@Override
	public int hashCode();
	
	@Override
	public CacheModel<Insult> toCacheModel();
	
	@Override
	public Insult toEscapedModel();
	
	@Override
	public Insult toUnescapedModel();
	
	@Override
	public String toString();
	
	@Override
	public String toXmlString();
}